import Environment from './Environment.js';
import Job from './Job.js';
import Log from './Log.js';
import LogFmt from './LogFmt.js';

export default class JobsManager {

  static JOBS = [];

  static startJobs() {
    if (Environment.read('JOBS') === 'false') return;

    this._defaultJob();
    this._startJobs();
  }

  static _defaultJob() {
    this.add(Job.QUARTER_HOUR, () => {
      Log.debug(
        LogFmt.name('cron-job')
          .number('total-jobs', this.JOBS.length)
          .log()
      );
    }, 'Debug jobs pool')
  }

  static add(cronTime, callback, description = 'Custom') {
    const job = Job.start(cronTime, callback, description);
    this.JOBS.push(job);
  }

  static _startJobs() {
    // Override this method if you want to start jobs.
  }

}
