export default class LogFmt {

  static DELIMITER = ' ';
  static SEPARATOR = '=';
  static STRING_DELIMITER = "'";

  static name(name) {
    const logFmt = new LogFmt();
    logFmt.string("name", name);
    return logFmt;
  }

  static addLevel(log, level) {
    const levelFmt = new LogFmt();
    const levelString = levelFmt.string("level", level.toString().toLowerCase()).log();
    return `${levelString}${this.DELIMITER}${log}`;
  }

  static isStringLogFmt(log) {
    if (!log || !log.length) {
      return false;
    }
    return log.includes(this.SEPARATOR);
  }

  text;

  constructor() {
    this.text = "";
  }

  string(key, value) {
    this._append(key, `'${value}'`);
    return this;
  }

  bool(key, value) {
    if (value) {
      this._append(key, '1');
    } else {
      this._append(key, '0');
    }
    return this;
  }

  number(key, value) {
    this._append(key, `${value}`);
    return this;
  }

  decimal(key, value, decimals = 2) {
    this._append(key, `${value.toFixed(decimals)}`);
    return this;
  }

  log() {
    return this.text;
  }

  _append(key, value) {
    if (this.text.length) {
      this._concat(LogFmt.DELIMITER);
    }
    this._concat(key);
    this._concat(LogFmt.SEPARATOR);
    this._concat(value);
  }

  _concat(text) {
    this.text = this.text.concat(text);
  }

}
